Require Import committable.
Require Import Coq.Logic.Classical_Prop.
Require Import Coq.Lists.List.
Require Import Coq.Sets.Ensembles.
Require Import dep.
Require Import sets.
Require Import syntax.
Require Import trails.

Lemma committable_after_choose_left :
  forall c id p,
    let t := thread_trail id p in
        let t' := thread_trail id (path_cons path_left p) in
            ~ In trail c t ->
            committable (Union trail c (Singleton trail t)) ->
            committable (Union trail c (Singleton trail t')).

intros c id p t t' t_not_in_c comm_before.
unfold committable in comm_before.
destruct comm_before as 
  [ uniq_heap [ uniq_thread [ parent_thread parent_heap ] ] ].
destruct uniq_heap as [ hp [ hp_in_c hp_uniq ] ].
remember (heap_trail hp) as ht.
assert (In trail c ht) as ht_in_c.
inversion hp_in_c. auto. inversion H. inversion H. subst ht t. inversion H1.
subst ht. clear hp_in_c.

unfold committable.

split. exists hp. split. left. apply ht_in_c.
intros hp' ht'_in_after. apply hp_uniq.
remember (heap_trail hp') as ht'.
destruct ht'_in_after as [ ht'_in_c | ht' false ].
left. auto. subst ht' t'. inversion false.

split. intros id1 p1 p2 t1_in_after t2_in_after.
subst t'. inversion t1_in_after; inversion t2_in_after; subst.
eapply uniq_thread. left. eauto. left. eauto.
inversion H1. subst id1.
assert (p1 = p) as p1_is_p.
eapply uniq_thread. left. eauto. subst t. right. apply In_singleton.
subst p1. tauto.
inversion H. subst id1.
assert (p2 = p) as p2_is_p.
eapply uniq_thread. left. eauto. subst t. right. apply In_singleton.
subst p2. tauto.
inversion H. inversion H1. reflexivity.

split.
intros t1 id2 p2 t1_in_after t2_in_dep_t1. subst t t'.
destruct t1_in_after as [ t1 t1_in_c | t1 t1_is_t' ].
induction t1 as [ id1 p1 | hp1 ].
assert (exists p2' : path,
  In trail (Union trail c (Singleton trail (thread_trail id p)))
  (thread_trail id2 p2') /\ extends p2' p2) as p2'_exists.
eapply parent_thread. left. apply t1_in_c. apply t2_in_dep_t1.
destruct p2'_exists as [ p2' [ t2'_in_before p2'_extends_p2 ] ].
assert (id = id2 \/ id <> id2) as cases. apply classic.
destruct cases as [ id_is_id2 | id_not_id2 ].
subst id2. exists (path_cons path_left p). 
split. right. apply In_singleton. eapply extends_trans.
apply extends_cons. apply extends_refl.
assert (p = p2') as p_is_p2'.
eapply uniq_thread. right. apply In_singleton. apply t2'_in_before.
subst p2'. apply p2'_extends_p2.
inversion t2'_in_before. 
exists p2'. split. left. auto. auto.
inversion H. tauto.
assert (exists p2' : path,
  In trail (Union trail c (Singleton trail (thread_trail id p)))
  (thread_trail id2 p2') /\ extends p2' p2) as p2'_exists.
eapply parent_thread. left. apply t1_in_c. auto.
destruct p2'_exists as [ p2' [ t2'_in_before p2'_extends_p2 ] ].
assert (id = id2 \/ id <> id2) as cases. apply classic.
destruct cases as [ id_is_id2 | id_not_id2 ].
subst id2. exists (path_cons path_left p). 
split. right. apply In_singleton. eapply extends_trans.
apply extends_cons. apply extends_refl.
assert (p = p2') as p_is_p2'.
eapply uniq_thread. right. apply In_singleton. apply t2'_in_before.
subst p2'. apply p2'_extends_p2.
inversion t2'_in_before. exists p2'. split. left. auto. auto.
inversion H. tauto.

inversion t1_is_t'. subst t1.
unfold dep in t2_in_dep_t1. simpl in t2_in_dep_t1.
unfold Add in t2_in_dep_t1. rewrite union_swap in t2_in_dep_t1.
inversion t2_in_dep_t1.
inversion H. subst. esplit. split. right. apply H. apply extends_refl.
assert (exists p2' : path, In trail
  (Union trail c (Singleton trail (thread_trail id p)))
  (thread_trail id2 p2') /\ extends p2' p2) as p2'_exists.
eapply parent_thread. right. apply In_singleton.
left. simpl. auto.
destruct p2'_exists as [ p2' [ t2'_in_before p2'_extends_p2 ] ].
assert (id = id2 \/ id <> id2) as cases. apply classic.
destruct cases as [ id_is_id2 | id_not_id2 ].
subst id2. assert (p = p2'). eapply uniq_thread.
right. apply In_singleton. auto. subst p2'.
exists (path_cons path_left p). split. right. apply In_singleton.
eapply extends_trans. apply extends_cons. apply extends_refl. auto.
remember (thread_trail id2 p2') as t2'.
destruct t2'_in_before as [ t2' t2'_in_c | t2' false ].
exists p2'. split. left. subst t2'. auto. auto.
subst t2'. inversion false. tauto.

intros t1 hp2 t1_in_after ht2_in_t1.
destruct t1_in_after as [ t1 t1_in_c | t1 t1_is_t' ].
exists hp. split. left. auto.
assert (exists hp2' : heap_path,
  In trail (Union trail c (Singleton trail t))
  (heap_trail hp2') /\ heap_extends hp2' hp2) as hp2'_exists.
eapply parent_heap. left. eauto. auto.
destruct hp2'_exists as [ hp2' [ ht2'_in_before hp2'_extends_hp2 ] ].
assert (hp = hp2') as hp_is_hp2'. apply hp_uniq. auto. subst hp2'. auto.

inversion t1_is_t'. subst t'. subst t1.
unfold dep in ht2_in_t1. simpl in ht2_in_t1.
unfold Add in ht2_in_t1. rewrite union_swap in ht2_in_t1.
inversion ht2_in_t1. subst. inversion H.
assert (exists hp2' : heap_path,
  In trail (Union trail c (Singleton trail t))
  (heap_trail hp2') /\ heap_extends hp2' hp2) as hp2'_exists.
eapply parent_heap. right. apply In_singleton.
subst t. left. simpl. auto.
destruct hp2'_exists as [ hp2' [ hp2'_in_before hp2'_extends_hp2 ] ].
remember (heap_trail hp2') as ht2'.
destruct hp2'_in_before as [ ht2' ht2'_in_c | ht2' ht2'_is_s ].
exists hp2'. split. left. subst ht2'. auto. auto.
subst t ht2'. inversion ht2'_is_s.

Qed.

Lemma committable_after_choose_right :
  forall c id p,
    let t := thread_trail id p in
        let t' := thread_trail id (path_cons path_right p) in
            ~ In trail c t ->
            committable (Union trail c (Singleton trail t)) ->
            committable (Union trail c (Singleton trail t')).

intros c id p t t' t_not_in_c comm_before.
unfold committable in comm_before.
destruct comm_before as 
  [ uniq_heap [ uniq_thread [ parent_thread parent_heap ] ] ].
destruct uniq_heap as [ hp [ hp_in_c hp_uniq ] ].
remember (heap_trail hp) as ht.
assert (In trail c ht) as ht_in_c.
inversion hp_in_c. auto. inversion H. inversion H. subst ht t. inversion H1.
subst ht. clear hp_in_c.

unfold committable.

split. exists hp. split. left. apply ht_in_c.
intros hp' ht'_in_after. apply hp_uniq.
remember (heap_trail hp') as ht'.
destruct ht'_in_after as [ ht'_in_c | ht' false ].
left. auto. subst ht' t'. inversion false.

split. intros id1 p1 p2 t1_in_after t2_in_after.
subst t'. inversion t1_in_after; inversion t2_in_after; subst.
eapply uniq_thread. left. eauto. left. eauto.
inversion H1. subst id1.
assert (p1 = p) as p1_is_p.
eapply uniq_thread. left. eauto. subst t. right. apply In_singleton.
subst p1. tauto.
inversion H. subst id1.
assert (p2 = p) as p2_is_p.
eapply uniq_thread. left. eauto. subst t. right. apply In_singleton.
subst p2. tauto.
inversion H. inversion H1. reflexivity.

split.
intros t1 id2 p2 t1_in_after t2_in_dep_t1. subst t t'.
destruct t1_in_after as [ t1 t1_in_c | t1 t1_is_t' ].
induction t1 as [ id1 p1 | hp1 ].
assert (exists p2' : path,
  In trail (Union trail c (Singleton trail (thread_trail id p)))
  (thread_trail id2 p2') /\ extends p2' p2) as p2'_exists.
eapply parent_thread. left. apply t1_in_c. apply t2_in_dep_t1.
destruct p2'_exists as [ p2' [ t2'_in_before p2'_extends_p2 ] ].
assert (id = id2 \/ id <> id2) as cases. apply classic.
destruct cases as [ id_is_id2 | id_not_id2 ].
subst id2. exists (path_cons path_right p). 
split. right. apply In_singleton. eapply extends_trans.
apply extends_cons. apply extends_refl. assert (p = p2') as p_is_p2'.
eapply uniq_thread. right. apply In_singleton. apply t2'_in_before.
subst p2'. apply p2'_extends_p2.
inversion t2'_in_before. exists p2'. split. left. auto. auto.
inversion H. tauto.
assert (exists p2' : path,
  In trail (Union trail c (Singleton trail (thread_trail id p)))
  (thread_trail id2 p2') /\ extends p2' p2) as p2'_exists.
eapply parent_thread. left. apply t1_in_c. auto.
destruct p2'_exists as [ p2' [ t2'_in_before p2'_extends_p2 ] ].
assert (id = id2 \/ id <> id2) as cases. apply classic.
destruct cases as [ id_is_id2 | id_not_id2 ].
subst id2. exists (path_cons path_right p). 
split. right. apply In_singleton. eapply extends_trans.
apply extends_cons. apply extends_refl. assert (p = p2') as p_is_p2'.
eapply uniq_thread. right. apply In_singleton. apply t2'_in_before.
subst p2'. apply p2'_extends_p2.
inversion t2'_in_before. exists p2'. split. left. auto. auto.
inversion H. tauto.

inversion t1_is_t'. subst t1.
unfold dep in t2_in_dep_t1. simpl in t2_in_dep_t1.
unfold Add in t2_in_dep_t1. rewrite union_swap in t2_in_dep_t1.
inversion t2_in_dep_t1.
inversion H. subst. esplit. split. right. apply H. apply extends_refl.
assert (exists p2' : path, In trail
  (Union trail c (Singleton trail (thread_trail id p)))
  (thread_trail id2 p2') /\ extends p2' p2) as p2'_exists.
eapply parent_thread. right. apply In_singleton.
left. simpl. auto.
destruct p2'_exists as [ p2' [ t2'_in_before p2'_extends_p2 ] ].
assert (id = id2 \/ id <> id2) as cases. apply classic.
destruct cases as [ id_is_id2 | id_not_id2 ].
subst id2. assert (p = p2'). eapply uniq_thread.
right. apply In_singleton. auto. subst p2'.
exists (path_cons path_right p). split. right. apply In_singleton.
eapply extends_trans. apply extends_cons. apply extends_refl. auto.
remember (thread_trail id2 p2') as t2'.
destruct t2'_in_before as [ t2' t2'_in_c | t2' false ].
exists p2'. split. left. subst t2'. auto. auto.
subst t2'. inversion false. tauto.

intros t1 hp2 t1_in_after ht2_in_t1.
destruct t1_in_after as [ t1 t1_in_c | t1 t1_is_t' ].
exists hp. split. left. auto.
assert (exists hp2' : heap_path,
  In trail (Union trail c (Singleton trail t))
  (heap_trail hp2') /\ heap_extends hp2' hp2) as hp2'_exists.
eapply parent_heap. left. eauto. auto.
destruct hp2'_exists as [ hp2' [ ht2'_in_before hp2'_extends_hp2 ] ].
assert (hp = hp2') as hp_is_hp2'. apply hp_uniq. auto. subst hp2'. auto.

inversion t1_is_t'. subst t'. subst t1.
unfold dep, dep_aux, Add in ht2_in_t1. rewrite union_swap in ht2_in_t1.
inversion ht2_in_t1. subst. inversion H.
assert (exists hp2' : heap_path,
  In trail (Union trail c (Singleton trail t))
  (heap_trail hp2') /\ heap_extends hp2' hp2) as hp2'_exists.
eapply parent_heap. right. apply In_singleton.
subst t. left. simpl. auto.
destruct hp2'_exists as [ hp2' [ hp2'_in_before hp2'_extends_hp2 ] ].
remember (heap_trail hp2') as ht2'.
destruct hp2'_in_before as [ ht2' ht2'_in_c | ht2' ht2'_is_s ].
exists hp2'. split. left. subst ht2'. auto. auto.
subst t ht2'. inversion ht2'_is_s.

Qed.
