Require Import coherent.
Require Import committable.
Require Import Coq.Lists.List.
Require Import Coq.Logic.Classical_Prop.
Require Import Coq.Sets.Ensembles.
Require Import lowlevel.
Require Import highlevel.
Require Import syntax.
Require Import trails.
Require Import hl2ll_get_S.

Lemma hl2ll_begin_ld : 
  forall H' H'' S_hl S_hl' s' thread_trails hp trails 
    S_H0 S_H S S0 S_all H T S_susp,
    hl_sync_step H' S_hl None H'' S_hl' (Some s') ->
    hl_unique_tids S_hl ->
    (forall t, In trail thread_trails t ->
      exists id, exists p, exists list_M, exists e, 
        t = thread_trail id p /\ In hl_thread S_hl (id, list_M, e)) ->
    (forall id list_M e,  In hl_thread S_hl (id, list_M, e) ->
      exists p, In trail thread_trails (thread_trail id p)) ->
    S_H = Add search_heap S_H0 (H', hp) ->
      S = get_S_no_ld S_hl thread_trails ->
      S_all = Union search_thread S S0 ->
      trails = Add trail thread_trails (heap_trail hp) ->
        committable trails ->
        exists thread_trails', exists hp', exists S_H', exists S0',
          let S' := get_S_ld H'' S_hl' s' thread_trails' hp' in
            let S_all' := Union search_thread S' S0' in
              let trails' := Add trail thread_trails' (heap_trail hp') in
                (forall t', 
                  In trail thread_trails' t' ->
                  exists id, exists p', exists list_M', exists e', 
                    t' = thread_trail id p' /\
                      (In hl_thread S_hl' (id, list_M', e')
                      \/ s' = (id, list_M', e'))) /\
                (forall id list_M' e',  
                  (In hl_thread S_hl' (id, list_M', e') 
                    \/ s' = (id, list_M', e')) ->
                  exists p', 
                    In trail thread_trails' (thread_trail id p')) /\
                committable trails' /\
                (ll_step (frozen H) T S_susp S_H S_all
                  (frozen H) T S_susp S_H' S_all').

intros H' H'' S_hl S_hl' s' thread_trails hp trails S_H0 S_H S
  S0 S_all H T S_susp hl_steps S_hl_unique trails_in_S_hl
  S_hl_in_trails S_H_eq S_eq S_all_eq trails_eq comm_trails.

subst S_H S S_all trails.

inversion hl_steps as [ | | | _H' _S_hl' _s' s'_not_in_S_hl' H'_eq S_hl_eq
  none_is_none H'_is_H'' S_hl'_eq s'_eq | | | | | ].
subst _H' _S_hl' _s' S_hl.

induction s' as [ [ id_ld list_M_ld ] e_ld ].
assert (exists! p_ld, In trail thread_trails (thread_trail id_ld p_ld)) 
  as p_ld_exists_unique.
assert (exists p_ld, In trail thread_trails (thread_trail id_ld p_ld)) 
  as p_ld_exists. eapply S_hl_in_trails. right. apply In_singleton.
destruct p_ld_exists as [ p_ld p_ld_in_thread_trails ].
exists p_ld. split. auto.
intros p_ld' p_ld'_in_thread_trails.
unfold committable in comm_trails.
destruct comm_trails as [ uniq_heap [ uniq_thread other ] ].
eapply uniq_thread. left. eauto. left. eauto.
destruct p_ld_exists_unique as [ p_ld p_ld_unique ].
unfold unique in p_ld_unique.
destruct p_ld_unique as [ p_ld_in_thread_trails p_ld_unique ].
assert (forall list_M e,
~ In hl_thread S_hl' (id_ld, list_M, e)) as id_ld_not_in_S_hl'.
assert (forall list_M e,
In hl_thread S_hl' (id_ld, list_M, e) ->
(id_ld, list_M, e) = (id_ld, list_M_ld, e_ld)) as if_id_ld_in_S_hl'.
intros list_M e in_S_hl'.
unfold hl_unique_tids in S_hl_unique.
apply NNPP. unfold not at 1. unfold not at 2 in S_hl_unique.
intros false. eapply S_hl_unique. reflexivity. reflexivity.
left. eauto. right. apply In_singleton. auto. reflexivity.
intros list_M e. unfold not. intros false.
assert ((id_ld, list_M, e) = (id_ld, list_M_ld, e_ld)) as eq.
apply if_id_ld_in_S_hl'. auto. rewrite -> eq in false.
destruct s'_not_in_S_hl'. auto.
exists thread_trails.
exists hp.
exists (Add search_heap S_H0 (H'', hp)).
exists (Add search_thread S0 (id_ld, None, list_M_ld, e_ld, p_ld)).

intros S' S_all' trails'. subst S' S_all' trails'.

split. intros t in_trails.
assert (exists id : tid,
  exists p : path,
    exists list_M : list ctxt,
      exists e : exp,
        t = thread_trail id p /\
        In hl_thread
        (Add hl_thread S_hl' (id_ld, list_M_ld, e_ld))
        (id, list_M, e)) 
as [ id [ p [ list_M [ e [ t_is_thread in_S_hl ] ] ] ] ].
apply trails_in_S_hl. auto.
inversion in_S_hl.
repeat esplit. apply t_is_thread. left. eauto.
repeat esplit. apply t_is_thread. right. eauto.
inversion H0. reflexivity.

split. intros id list_M e t_in_S_hl'_or_t_ld.
destruct t_in_S_hl'_or_t_ld as [ t_in_S_hl' | t_is_t_ld ].
assert (exists p, In trail thread_trails (thread_trail id p)) as p_exists.
eapply S_hl_in_trails. left. apply t_in_S_hl'.
destruct p_exists as [ p p_in_thread_trails ].
exists p. auto.
exists p_ld.
inversion t_is_t_ld. subst id list_M e. auto.

split. auto.

remember (Union search_thread (get_S_no_ld (Add hl_thread S_hl' 
  (id_ld, list_M_ld, e_ld)) thread_trails) S0) as S.
assert (Union search_thread
  (get_S_ld H'' S_hl' (id_ld, list_M_ld, e_ld)
    thread_trails hp)
  (Add search_thread S0 (id_ld, None, list_M_ld, e_ld, p_ld)) =
  Add search_thread S
    (id_ld, Some (H', hp), list_M_ld, e_ld, p_ld))
as rewriting.
subst S. apply Extensionality_Ensembles. split; intros x x_in_one.
destruct x_in_one as [ x x_in_S | x other ].
inversion x_in_S. left. left. apply In_S_no_ld. left. auto.
auto. right. inversion H0. 
assert (p_ld = p). apply p_ld_unique. subst id. auto.
subst p. subst H''. apply In_singleton.
destruct other as [ x x_in_S0 | x x_is_t_ld ].
left. right. auto. inversion x_is_t_ld.
left. left. apply In_S_no_ld. right. apply In_singleton. auto.
destruct x_in_one as [ x x_in_S_all | x x_is_t_ld' ].
destruct x_in_S_all as [ x x_in_S | x x_in_S0 ].
inversion x_in_S. inversion H0.
subst x x0. left. apply In_S_not_ld. auto.
auto.
inversion H3. subst. assert (p_ld = p). apply p_ld_unique. auto.
subst p. right. right. apply In_singleton.
right. left. auto.
inversion x_is_t_ld'. subst x.
left. subst H'.  apply In_ld. reflexivity. auto.
rewrite -> rewriting. clear rewriting. subst S. subst H''.
apply ll_step_begin_lockdown.
right. apply In_singleton.
left. apply In_S_no_ld. right. apply In_singleton. auto.
eapply committable_implies_heap_coherent.
apply comm_trails. left. auto. right. apply In_singleton.

Qed.
