Require Import committable.
Require Import committable_after_end_lockdown.
Require Import Coq.Lists.List.
Require Import Coq.Logic.Classical.
Require Import Coq.Sets.Powerset_Classical_facts.
Require Import Coq.Sets.Ensembles.
Require Import lowlevel.
Require Import highlevel.
Require Import sets.
Require Import syntax.
Require Import trails.
Require Import hl2ll_get_S.

Lemma hl2ll_end_ld : 
  forall H' H'' S_hl S_hl' s thread_trails hp trails 
    S_H S S0 S_all H T S_susp,
    hl_sync_step H' S_hl (Some s) H'' S_hl' None ->
    ld_unique_tids S_hl (Some s) ->
    (forall t, In trail thread_trails t ->
      exists id, exists p, exists list_M, exists e, 
        t = thread_trail id p /\ 
        (In hl_thread S_hl (id, list_M, e) \/ 
          s = (id, list_M, e))) ->
    (forall id list_M e,  
      (In hl_thread S_hl (id, list_M, e)
        \/ s = (id, list_M, e)) ->
      exists p, In trail thread_trails (thread_trail id p)) ->
    S = get_S_ld H' S_hl s thread_trails hp ->
    S_all = Union search_thread S S0 ->
    trails = Add trail thread_trails (heap_trail hp) ->
      committable trails ->
      exists thread_trails', exists hp', exists S_H0', exists S0',
        let S' := get_S_no_ld S_hl' thread_trails' in
          let S_all' := Union search_thread S' S0' in
            let S_H' := Add search_heap S_H0' (H'', hp') in
              let trails' := Add trail thread_trails' (heap_trail hp') in
                (forall t', 
                  In trail thread_trails' t' ->
                  exists id, exists p', exists list_M', exists e', 
                    t' = (thread_trail id p') /\
                    In hl_thread S_hl' (id, list_M', e')) /\
                (forall id list_M' e',  
                  In hl_thread S_hl' (id, list_M', e') ->
                  exists p', 
                    In trail thread_trails' (thread_trail id p')) /\
                committable trails' /\
                (ll_step (frozen H) T S_susp S_H S_all
                  (frozen H) T S_susp S_H' S_all').

intros H' H'' S_hl S_hl' s thread_trails hp trails S_H S S0 S_all H T S_susp
  hl_steps hl_before_unique trails_in_hl_before hl_before_in_trails
  S_eq S_all_eq trails_eq comm_before.

subst S S_all trails.

inversion hl_steps as [ | | | | _H' _S_hl id_ld  list_M_ld e_ld ldvalue_ld 
  H'_eq S_hl_eq s_eq H''_eq S_hl'_eq | | | | ].
subst _H' _S_hl s H'' S_hl'.

assert (exists! p_ld, In trail thread_trails (thread_trail id_ld p_ld)) 
  as p_ld_exists_unique.
assert (exists p_ld, In trail thread_trails (thread_trail id_ld p_ld)) 
  as p_ld_exists. eapply hl_before_in_trails. right. reflexivity.
destruct p_ld_exists as [ p_ld p_ld_in_thread_trails ].
exists p_ld. split. auto.
intros p_ld' p_ld'_in_thread_trails.
unfold committable in comm_before.
destruct comm_before as [ uniq_heap [ uniq_thread other ] ].
eapply uniq_thread. left. eauto. left. eauto.
destruct p_ld_exists_unique as [ p_ld p_ld_unique ].
unfold unique in p_ld_unique.
destruct p_ld_unique as [ p_ld_in_thread_trails p_ld_unique ].

assert (forall list_M e,
  ~ In hl_thread S_hl (id_ld, list_M, e)) as id_ld_not_in_S_hl.
unfold ld_unique_tids in hl_before_unique. destruct hl_before_unique.
intros list_M e. unfold not. intros in_S_hl.
unfold not in H1. eapply H1. eauto. reflexivity.

remember (get_fresh_nonce S_H (Union search_thread
  (get_S_ld H' S_hl (id_ld, list_M_ld, e_ld) thread_trails hp) S0)) as n_ld.
exists (Add trail (Subtract trail thread_trails
  (thread_trail id_ld p_ld))
  (thread_trail id_ld (path_cons (path_heap n_ld hp) p_ld))).
exists (heap_path_cons (heap_path_thread n_ld id_ld p_ld) hp).
exists S_H.
exists S0.

intros S' S_all' S_H' trails'. subst S' S_all' S_H' trails'.

(* subgoal 1 *)
split. Focus.
intros t t_in_thread_trails.
destruct t_in_thread_trails as 
  [ t [ t_in_thread_trails t_not_ld ] | t t_is_ld ].
assert (exists id, exists p, exists list_M, exists e,
  t = thread_trail id p /\ (In hl_thread S_hl (id, list_M, e) \/
    (id_ld, list_M_ld, e_ld) = (id, list_M, e))) as exists_before.
apply trails_in_hl_before. auto.
destruct exists_before as 
  [ id [ p [ list_M [ e [ t_is_trail [ t_in_S_hl | t_is_ld ] ] ] ] ] ];
exists id; exists p; exists list_M; exists e.
split. auto. left. auto.
split. auto. right. rewrite <- t_is_ld. apply In_singleton.
inversion t_is_ld. exists id_ld. exists (path_cons (path_heap n_ld hp) p_ld).
exists list_M_ld. exists e_ld. split. reflexivity. right. apply In_singleton.
Unfocus.

(* subgoal 2 *)
split. Focus.
intros id list_M e in_S_hl'.
inversion in_S_hl' as [ t t_in_S_hl | t t_is_ld ]; subst t.
assert (exists p, In trail thread_trails (thread_trail id p)) 
  as [ p in_trails ].
eapply hl_before_in_trails. left. eauto.
exists p. left. split. auto. intros false.
inversion false. subst id p. unfold not in id_ld_not_in_S_hl.
eapply id_ld_not_in_S_hl. apply t_in_S_hl.
inversion t_is_ld. subst id list_M e.
exists (path_cons (path_heap n_ld hp) p_ld). right. apply In_singleton.
Unfocus.

(* subgoal 3 *)
split. Focus.
rewrite add_add_to_union_couple. rewrite couple_swap.
apply committable_after_end_lockdown.
unfold not. intros false. destruct false as [ in_trails false ].
destruct false. apply In_singleton.
unfold not. intros false.
assert (exists id, exists p, exists list_M, exists e,
  heap_trail hp = thread_trail id p /\ (In hl_thread S_hl (id, list_M, e) \/
    (id_ld, list_M_ld, e_ld) = (id, list_M, e))) as is_thread.
apply trails_in_hl_before. inversion false. auto.
destruct is_thread as [ id [ p [ list_M [ e [ false2 other ] ] ] ] ].
inversion false2.
rewrite <- couple_swap.
rewrite <- add_add_to_union_couple.
rewrite <- add_subtract.
auto.
auto.
Unfocus.

(* subgoal 4*)
Focus.
remember (Union search_thread
  (Intersection search_thread
    (get_S_ld H' S_hl (id_ld, list_M_ld, e_ld) thread_trails hp)
    (get_S_no_ld (Add hl_thread S_hl (id_ld, list_M_ld, e_ld))
      (Add trail
        (Subtract trail thread_trails (thread_trail id_ld p_ld))
        (thread_trail id_ld (path_cons (path_heap n_ld hp) p_ld)))))
  S0) as S''.
assert (Union search_thread
  (get_S_ld H' S_hl (id_ld, list_M_ld, e_ld) thread_trails hp) S0 =
  Add search_thread S''
    (id_ld, Some (H', hp), list_M_ld, e_ld, p_ld)) as S_all_eq.
subst S''. apply Extensionality_Ensembles. split; intros x x_in_one.
destruct x_in_one as [x x_in_S | x x_in_S0 ].
inversion x_in_S as [ id list_M e p in_S_hl in_trails | 
  id list_M e p is_ld in_trails ].
left. left. split. apply In_S_not_ld. auto. auto.
apply In_S_no_ld. left. auto. left. split. auto.
intros false. inversion false. subst id_ld.
unfold not in id_ld_not_in_S_hl. eapply id_ld_not_in_S_hl. eauto.

inversion is_ld. subst id list_M e.
assert (p_ld = p). apply p_ld_unique. auto. subst p. right. apply In_singleton.
left. right. auto.

destruct x_in_one as [ x x_not_ld | x x_is_ld ].
destruct x_not_ld as [ x x_not_S0 | x x_in_S0 ].
left. destruct x_not_S0 as [ x x_in_get_S_ld x_in_get_S_no_ld ].
induction x as [ [ [ [ id r ] list_M ] e ] p ].
assert (id = id_ld \/ id <> id_ld) as [ id_is_ld | id_not_ld ].
apply classic. subst id. 
inversion x_in_get_S_ld.
assert False. unfold not in id_ld_not_in_S_hl. 
eapply id_ld_not_in_S_hl. eauto. tauto.
apply In_ld. auto. auto.
inversion x_in_get_S_ld.
apply In_S_not_ld. auto. auto.
destruct id_not_ld. inversion H2. reflexivity.
right. auto.
inversion x_is_ld. left.
apply In_ld. auto. auto.

rewrite S_all_eq.

assert (Union search_thread
  (get_S_no_ld (Add hl_thread S_hl (id_ld, list_M_ld, e_ld))
    (Add trail
      (Subtract trail thread_trails (thread_trail id_ld p_ld))
      (thread_trail id_ld (path_cons (path_heap n_ld hp) p_ld)))) S0 =
  Add search_thread S''
    (id_ld, None, list_M_ld, e_ld, (path_cons (path_heap n_ld hp) p_ld)
    )) as S_all'_eq.
subst S''. apply Extensionality_Ensembles. split; intros x x_in_one.
destruct x_in_one as [x x_in_S' | x x_in_S0].
assert (x = (id_ld, None, list_M_ld, e_ld, 
  path_cons (path_heap n_ld hp) p_ld) \/
  x <> (id_ld, None, list_M_ld, e_ld, 
    path_cons (path_heap n_ld hp) p_ld)) as [ x_is_ld | x_not_ld ].
apply classic. 
right. subst x. apply In_singleton.
inversion x_in_S' as [ id list_M e p in_S_hl in_trails ].
inversion in_S_hl as [ t t_in_S_hl | t t_is_ld ].
inversion in_trails as [ y [ y_in_trails y_not_ld ] | y y_is_ld ].
left. left. split. eapply In_S_not_ld. auto. auto.
eapply In_S_no_ld. left. auto. auto.
inversion y_is_ld. subst y id t p. right.
unfold not in id_ld_not_in_S_hl. assert False.
eapply id_ld_not_in_S_hl. apply t_in_S_hl. tauto.
inversion t_is_ld. subst t id list_M e.
inversion in_trails as [ y [ y_in_trails y_not_ld ] | y y_is_ld ].
assert (p_ld = p). apply p_ld_unique. auto. subst.
destruct y_not_ld. apply In_singleton.
inversion y_is_ld. right. apply In_singleton.
left. right. auto.

destruct x_in_one as [ x x_not_ld | x x_is_ld ].
destruct x_not_ld as [ x x_in_set | x x_in_S0 ].
destruct x_in_set as [ x x_in_get_S_ld x_in_get_S_no_ld ].
inversion x_in_get_S_no_ld as [ id list_M e p in_S_hl_or_ld in_trails ].
inversion in_S_hl_or_ld as [ t t_in_S_hl | t t_is_ld ].
inversion x_in_get_S_ld as [ id2 list_M2 e2 p2 in_S_hl_or_ld2 in_trails2 | 
  id2 list_M2 e2 p2 is_ld2 in_trails2 ].
subst x t. left. apply In_S_no_ld. left. auto. left. split.
auto. inversion H2. subst id2 list_M2 e2 p2. auto.
inversion H2. subst id2 list_M2 e2 p2.
intros false. inversion false. subst id p.
unfold not in id_ld_not_in_S_hl. eapply id_ld_not_in_S_hl. eauto.
inversion is_ld2. subst id2 list_M2 e2. subst x.
inversion H2.
inversion t_is_ld. subst id list_M e.
inversion in_trails. inversion H2.
assert (p_ld = p). apply p_ld_unique. auto. subst p.
destruct H5. apply In_singleton.
left. apply In_S_no_ld. inversion H2. right. apply In_singleton.
inversion H2. right. apply In_singleton.
right. auto.
left. inversion x_is_ld. apply In_S_no_ld.
right. apply In_singleton. right. apply In_singleton.
rewrite -> S_all'_eq.
apply ll_step_end_lockdown.

subst n_ld. subst S''.
rewrite <- S_all_eq.
apply get_fresh_nonce_correct.
auto.

Qed.

