Require Import Coq.Lists.List.
Require Import Coq.Sets.Ensembles.
Require Import lowlevel.
Require Import highlevel.
Require Import syntax.
Require Import trails.

Inductive get_S_no_ld (S_hl:Ensemble hl_thread)
  (thread_trails:Ensemble trail) : Ensemble search_thread :=
| In_S_no_ld : forall id list_M e p,
  In hl_thread S_hl (id, list_M, e) ->
  In trail thread_trails (thread_trail id p) ->
  (In search_thread (get_S_no_ld S_hl thread_trails) 
    (id, None, list_M, e, p)).

Inductive get_S_ld (H:heap) (S_hl:Ensemble hl_thread) (s:hl_thread)
  (thread_trails:Ensemble trail) (hp:heap_path) : Ensemble search_thread :=
| In_S_not_ld : forall id list_M e p,
  In hl_thread S_hl (id, list_M, e) ->
  In trail thread_trails (thread_trail id p) ->
  (In search_thread (get_S_ld H S_hl s thread_trails hp) 
    (id, None, list_M, e, p))
| In_ld : forall id list_M e p,
  s = (id, list_M, e) ->
  In trail thread_trails (thread_trail id p) ->
  (In search_thread (get_S_ld H S_hl s thread_trails hp) 
    (id, Some (H, hp), list_M, e, p)).

Inductive get_S_sync_init (S_hl:Ensemble hl_thread) : Ensemble search_thread :=
| In_S_sync_init : forall id v,
  In hl_thread S_hl (id, nil, v) ->
  In search_thread (get_S_sync_init S_hl) (id, None, nil, v, path_nil).

