Require Import committable.
Require Import Coq.Lists.List.
Require Import Coq.Sets.Ensembles.
Require Import hl2ll_get_S.
Require Import hl2ll_one.
Require Import highlevel.
Require Import lowlevel.
Require Import syntax.
Require Import trails.
Require Import unique_tids.

Lemma hl2ll_many :
  forall H' H'' S_hl S_hl' s s' thread_trails hp trails 
    S_H0 S_H S S0 S_all H T S_susp,
    hl_sync_step_many H' S_hl s H'' S_hl' s' ->
    ld_unique_tids S_hl s ->
    trails = Add trail thread_trails (heap_trail hp) ->
      committable trails ->
      S_all = Union search_thread S S0 ->
      (( (* no ld *)
        s = None /\
        (forall t, In trail thread_trails t ->
          exists id, exists p, exists list_M, exists e, 
            t = thread_trail id p /\ In hl_thread S_hl (id, list_M, e)) /\
        (forall id list_M e,  In hl_thread S_hl (id, list_M, e) ->
          exists p, In trail thread_trails (thread_trail id p)) /\
        S_H = Add search_heap S_H0 (H', hp) /\
          S = get_S_no_ld S_hl thread_trails)
      \/ ( (* ld *)
        exists id_ld, exists list_M_ld, exists e_ld,
          s = Some (id_ld, list_M_ld, e_ld) /\
          (forall t, In trail thread_trails t ->
            exists id, exists p, exists list_M, exists e, 
              t = thread_trail id p /\ 
              (In hl_thread S_hl (id, list_M, e) \/ 
                (id_ld, list_M_ld, e_ld) = (id, list_M, e))) /\
          (forall id list_M e,  
            (In hl_thread S_hl (id, list_M, e)
              \/ (id_ld, list_M_ld, e_ld) = (id, list_M, e)) ->
            exists p, In trail thread_trails (thread_trail id p)) /\
          S = get_S_ld H' S_hl (id_ld, list_M_ld, e_ld) thread_trails hp)) ->
      exists thread_trails', exists hp', exists S_H', exists S0', exists S',
        let S_all' := Union search_thread S' S0' in
          let trails' := Add trail thread_trails' (heap_trail hp') in
            committable trails' /\
            (ll_step_many (frozen H) T S_susp S_H S_all
              (frozen H) T S_susp S_H' S_all') /\
            (( (* no ld *)
              s' = None /\
              exists S_H0',
                S' = get_S_no_ld S_hl' thread_trails' /\
                S_H' = Add search_heap S_H0' (H'', hp') /\
                  (forall t', 
                    In trail thread_trails' t' ->
                    exists id, exists p', exists list_M', exists e', 
                      t' = thread_trail id p' /\
                      In hl_thread S_hl' (id, list_M', e')) /\
                  (forall id list_M' e',  
                    In hl_thread S_hl' (id, list_M', e') ->
                    exists p', 
                      In trail thread_trails' (thread_trail id p')))
            \/ ( (* ld *)
              exists id_ld', exists list_M_ld', exists e_ld',
                s' = Some (id_ld', list_M_ld', e_ld') /\
                S' = get_S_ld H'' S_hl' (id_ld', list_M_ld', e_ld') thread_trails' hp' /\
                (forall t', 
                  In trail thread_trails' t' ->
                  exists id, exists p', exists list_M', exists e', 
                    t' = thread_trail id p' /\
                    (In hl_thread S_hl' (id, list_M', e')
                      \/ (id_ld', list_M_ld', e_ld') = (id, list_M', e'))) /\
                (forall id list_M' e',  
                  (In hl_thread S_hl' (id, list_M', e') 
                    \/ (id_ld', list_M_ld', e_ld') = (id, list_M', e')) ->
                  exists p', 
                    In trail thread_trails' (thread_trail id p')))).

intros H' H'' S_hl S_hl' s s' thread_trails hp trails S_H0 S_H S S0 S_all H T S_susp
  hl_steps_many S_hl_unique trails_eq comm_before S_all_eq ld_or_no_ld.

generalize dependent thread_trails.
generalize dependent hp.
generalize dependent trails.
generalize dependent S.
generalize dependent S0.
generalize dependent S_H.
generalize dependent S_H0.
generalize dependent S_all.

induction hl_steps_many as [ H' S_hl s | H1 S_hl1 s1 H2 S_hl2 s2 H3 S_hl3 s3 step_1_2 step_many_2_3 IH ].

intros S_all S_H0 S_H S0 S S_all_eq trails comm_before hp thread_trails trails_eq ld_or_no_ld.
exists thread_trails. exists hp. exists S_H. exists S0. exists S.
intros S_all' trails'.
split. subst trails'. subst trails. apply comm_before.
split. subst S_all S_all'. apply ll_step_many_zero.
destruct ld_or_no_ld as [ [ s_is_None [ trails_in_S_hl [ S_hl_in_trails [ S_H_eq S_eq ] ] ] ]
  | [ id_ld [ list_M_ld [ e_ld [ s_is_Some [ trails_in_S_hl [ S_hl_in_trails S_eq ] ] ] ] ] ] ].
left. split. apply s_is_None. exists S_H0. split. apply S_eq. split. apply S_H_eq. split.
apply trails_in_S_hl.
apply S_hl_in_trails.
right. exists id_ld. exists list_M_ld. exists e_ld.
split. apply s_is_Some.
split. apply S_eq.
split.
apply trails_in_S_hl.
apply S_hl_in_trails.

intros S_all1 S_H01 S_H1 S01 S1 S_all1_eq trails1 comm1 hp1 thread_trails1 trails1_eq ld_or_no_ld1.
assert (exists thread_trails2, exists hp2, exists S_H2, exists S02, exists S2,
  let S_all2 := Union search_thread S2 S02 in
    let trails2 := Add trail thread_trails2 (heap_trail hp2) in
      committable trails2 /\
      (ll_step (frozen H) T S_susp S_H1 S_all1
        (frozen H) T S_susp S_H2 S_all2) /\
      (( (* no ld *)
        s2 = None /\
        exists S_H02,
          S2 = get_S_no_ld S_hl2 thread_trails2 /\
          S_H2 = Add search_heap S_H02 (H2, hp2) /\
            (forall t2, 
              In trail thread_trails2 t2 ->
              exists id, exists p2, exists list_M2, exists e2, 
                t2 = thread_trail id p2 /\ 
                In hl_thread S_hl2 (id, list_M2, e2)) /\
            (forall id list_M2 e2,  
              In hl_thread S_hl2 (id, list_M2, e2) ->
              exists p2, 
                In trail thread_trails2 (thread_trail id p2)))
      \/ ( (* ld *)
        exists id_ld2, exists list_M_ld2, exists e_ld2,
          s2 = Some (id_ld2, list_M_ld2, e_ld2) /\
          S2 = get_S_ld H2 S_hl2 (id_ld2, list_M_ld2, e_ld2) thread_trails2 hp2 /\
          (forall t2, 
            In trail thread_trails2 t2 ->
            exists id, exists p2, exists list_M2, exists e2, 
              t2 = thread_trail id p2 /\
              (In hl_thread S_hl2 (id, list_M2, e2)
                \/ (id_ld2, list_M_ld2, e_ld2) = (id, list_M2, e2))) /\
          (forall id list_M2 e2,  
            (In hl_thread S_hl2 (id, list_M2, e2) 
              \/ (id_ld2, list_M_ld2, e_ld2) = (id, list_M2, e2)) ->
            exists p2, 
              In trail thread_trails2 (thread_trail id p2))))) as rewriting2.
eapply hl2ll_one. apply step_1_2. apply S_hl_unique. apply trails1_eq. apply comm1. apply S_all1_eq.
apply ld_or_no_ld1.
destruct rewriting2 as [ thread_trails2 [ hp2 [ S_H2 [ S02 [ S2 [ comm2 [ ll_step_1_2 ld_or_not_ld2 ] ] ] ] ] ] ].
remember (Union search_thread S2 S02) as S_all2.
assert (exists thread_trails3 : Ensemble trail,
  exists hp3 : heap_path,
    exists S_H3 : Ensemble search_heap,
      exists S03 : Ensemble search_thread,
        exists S3 : Ensemble search_thread,
          let S_all3 := Union search_thread S3 S03 in
            let trails3 := Add trail thread_trails3 (heap_trail hp3) in
              committable trails3 /\
              ll_step_many (frozen H) T S_susp S_H2 S_all2 
              (frozen H) T S_susp S_H3 S_all3 /\
              (s3 = None /\
                (exists S_H03 : Ensemble search_heap,
                  S3 = get_S_no_ld S_hl3 thread_trails3 /\
                  S_H3 = Add search_heap S_H03 (H3, hp3) /\
                    (forall t3,
                      In trail thread_trails3 t3 ->
                      exists id, exists p3, exists list_M3 : list ctxt,
                        exists e3 : exp, 
                          t3 = thread_trail id p3 /\
                          In hl_thread S_hl3 (id, list_M3, e3)) /\
                    (forall (id : tid) (list_M3 : list ctxt) (e3 : exp),
                      In hl_thread S_hl3 (id, list_M3, e3) ->
                      exists p3 : path,
                        In trail thread_trails3 (thread_trail id p3))) \/
                (exists id_ld3 : tid,
                  exists list_M_ld3 : list ctxt,
                    exists e_ld3 : exp,
                      s3 = Some (id_ld3, list_M_ld3, e_ld3) /\
                      S3 = get_S_ld H3 S_hl3 (id_ld3, list_M_ld3, e_ld3)
                      thread_trails3 hp3 /\
                      (forall t3,
                        In trail thread_trails3 t3 ->
                        exists id, exists p3, exists list_M3 : list ctxt,
                          exists e3 : exp,
                            t3 = thread_trail id p3 /\ 
                            (In hl_thread S_hl3 (id, list_M3, e3) \/
                              (id_ld3, list_M_ld3, e_ld3) = (id, list_M3, e3))) /\
                      (forall (id : tid) (list_M3 : list ctxt) (e3 : exp),
                        In hl_thread S_hl3 (id, list_M3, e3) \/
                        (id_ld3, list_M_ld3, e_ld3) = (id, list_M3, e3) ->
                        exists p3 : path,
                          In trail thread_trails3 (thread_trail id p3))))) as ind_step.
destruct ld_or_not_ld2 as [ld2 | no_ld_2].
destruct ld2 as [s2_is_None [ S_H02 [ S2_eq [ S_H2_eq [ trails2_in_S_hl2 S_hl2_in_trails2]]]]].
eapply IH.
eapply hl_sync_step_preserves_unique_tids.
apply step_1_2.
apply S_hl_unique.
apply HeqS_all2.
apply comm2.
reflexivity.
left.
split. apply s2_is_None. split.
apply trails2_in_S_hl2.
split. apply S_hl2_in_trails2.
split. subst S_H2. reflexivity.
apply S2_eq.
destruct no_ld_2 as [ id_ld2 [ list_M_ld2 [ e_ld2 [ s2_eq [ S2_eq [ trails2_in_S_hl2 S_hl2_in_trails2 ] ] ] ] ] ].
eapply IH with (S_H0 := Empty_set search_heap).
eapply hl_sync_step_preserves_unique_tids.
apply step_1_2.
apply S_hl_unique.
apply HeqS_all2.
apply comm2.
reflexivity.
right.
exists id_ld2. exists list_M_ld2. exists e_ld2.
split. apply s2_eq.
split. apply trails2_in_S_hl2.
split. apply S_hl2_in_trails2.
apply S2_eq.

destruct ind_step as [ thread_trails3 [ hp3 [ S_H3 [ S03 [ S3 [ comm3 [ step_2_3 ld_or_no_ld_3 ] ] ] ] ] ] ].
exists thread_trails3. exists hp3. exists S_H3. exists S03. exists S3.
intros S_all3 trails3.
split. subst trails3. apply comm3.
split. eapply ll_step_many_nonzero.
apply ll_step_1_2. apply step_2_3.
apply ld_or_no_ld_3.
Qed.

