Require Import committable.
Require Import Coq.Lists.List.
Require Import Coq.Sets.Ensembles.
Require Import hl2ll_begin_ld.
Require Import hl2ll_end_ld.
Require Import hl2ll_ld.
Require Import hl2ll_no_ld.
Require Import hl2ll_get_S.
Require Import highlevel.
Require Import lowlevel.
Require Import syntax.
Require Import trails.

Lemma hl2ll_one :
  forall H' H'' S_hl S_hl' s s' thread_trails hp trails 
    S_H0 S_H S S0 S_all H T S_susp,
    hl_sync_step H' S_hl s H'' S_hl' s' ->
    ld_unique_tids S_hl s ->
    trails = Add trail thread_trails (heap_trail hp) ->
      committable trails ->
      S_all = Union search_thread S S0 ->
      (( (* no ld *)
        s = None /\
        (forall t, In trail thread_trails t ->
          exists id, exists p, exists list_M, exists e, 
            t = thread_trail id p /\ In hl_thread S_hl (id, list_M, e)) /\
        (forall id list_M e,  In hl_thread S_hl (id, list_M, e) ->
          exists p, In trail thread_trails (thread_trail id p)) /\
        S_H = Add search_heap S_H0 (H', hp) /\
          S = get_S_no_ld S_hl thread_trails)
      \/ ( (* ld *)
        exists id_ld, exists list_M_ld, exists e_ld,
          s = Some (id_ld, list_M_ld, e_ld) /\
          (forall t, In trail thread_trails t ->
            exists id, exists p, exists list_M, exists e, 
              t = thread_trail id p /\ 
              (In hl_thread S_hl (id, list_M, e) \/ 
                (id_ld, list_M_ld, e_ld) = (id, list_M, e))) /\
          (forall id list_M e,  
            (In hl_thread S_hl (id, list_M, e)
              \/ (id_ld, list_M_ld, e_ld) = (id, list_M, e)) ->
            exists p, In trail thread_trails (thread_trail id p)) /\
          S = get_S_ld H' S_hl (id_ld, list_M_ld, e_ld) thread_trails hp)) ->
      exists thread_trails', exists hp', exists S_H', exists S0', exists S',
        let S_all' := Union search_thread S' S0' in
          let trails' := Add trail thread_trails' (heap_trail hp') in
            committable trails' /\
            (ll_step (frozen H) T S_susp S_H S_all
              (frozen H) T S_susp S_H' S_all') /\
            (( (* no ld *)
              s' = None /\
              exists S_H0',
                S' = get_S_no_ld S_hl' thread_trails' /\
                S_H' = Add search_heap S_H0' (H'', hp') /\
                  (forall t', 
                    In trail thread_trails' t' ->
                    exists id, exists p', exists list_M', exists e', 
                      t' = thread_trail id p' /\ 
                      In hl_thread S_hl' (id, list_M', e')) /\
                  (forall id list_M' e',  
                    In hl_thread S_hl' (id, list_M', e') ->
                    exists p', 
                      In trail thread_trails' (thread_trail id p')))
            \/ ( (* ld *)
              exists id_ld', exists list_M_ld', exists e_ld',
                s' = Some (id_ld', list_M_ld', e_ld') /\
                S' = get_S_ld H'' S_hl' (id_ld', list_M_ld', e_ld') thread_trails' hp' /\
                (forall t', 
                  In trail thread_trails' t' ->
                  exists id, exists p', exists list_M', exists e', 
                    t' = thread_trail id p' /\ 
                    (In hl_thread S_hl' (id, list_M', e')
                      \/ (id_ld', list_M_ld', e_ld') = (id, list_M', e'))) /\
                (forall id list_M' e',  
                  (In hl_thread S_hl' (id, list_M', e') 
                    \/ (id_ld', list_M_ld', e_ld') = (id, list_M', e')) ->
                  exists p', 
                    In trail thread_trails' (thread_trail id p')))).

intros H' H'' S_hl S_hl' s s' thread_trails hp trails S_H0 S_H S S0 S_all H T S_susp
  hl_steps S_hl_unique trails_eq comm_before S_all_eq to_be_split.

destruct to_be_split as [ no_ld_before | ld_before ].
destruct no_ld_before as [ s_is_None [ trails_in_S_hl [ S_hl_in_trails [ S_H_eq S_eq ] ] ] ].
subst s.
induction s' as [ s_ld' | ].

(* begin ld *)
assert (exists thread_trails', exists hp', exists S_H', exists S0',
  let S' := get_S_ld H'' S_hl' s_ld' thread_trails' hp' in
    let S_all' := Union search_thread S' S0' in
      let trails' := Add trail thread_trails' (heap_trail hp') in
        (forall t', 
          In trail thread_trails' t' ->
          exists id, exists p', exists list_M', exists e', 
            t' = thread_trail id p' /\ 
            (In hl_thread S_hl' (id, list_M', e')
              \/ s_ld' = (id, list_M', e'))) /\
        (forall id list_M' e',  
          (In hl_thread S_hl' (id, list_M', e') 
            \/ s_ld' = (id, list_M', e')) ->
          exists p', 
            In trail thread_trails' (thread_trail id p')) /\
        committable trails' /\
        (ll_step (frozen H) T S_susp S_H S_all
          (frozen H) T S_susp S_H' S_all')) as begin_ld.
eapply hl2ll_begin_ld.
apply hl_steps.
unfold ld_unique_tids in S_hl_unique. eapply proj1. apply S_hl_unique.
apply trails_in_S_hl.
apply S_hl_in_trails.
apply S_H_eq.
apply S_eq.
apply S_all_eq.
apply trails_eq.
apply comm_before.
destruct begin_ld as [ thread_trails' [ hp' [ S_H' [ S0' [ trails'_in_S_hl' [ S_hl'_in_trails' [ comm_after ll_steps ] ] ] ] ] ] ].
exists thread_trails'. exists hp'. exists S_H'. exists S0'. exists (get_S_ld H'' S_hl' s_ld' thread_trails' hp').
intros S_all' trails'.
split. subst trails'. apply comm_after.
split. subst S_all'. apply ll_steps.
right. induction s_ld' as [ [ id_ld' list_M_ld' ] e_ld' ].
exists id_ld'. exists list_M_ld'. exists e_ld'.
split. reflexivity.
split. reflexivity.
split. apply trails'_in_S_hl'.
apply S_hl'_in_trails'.

(* no ld *)
assert (exists thread_trails', exists hp', exists S_H0', exists S0',
        let S' := get_S_no_ld S_hl' thread_trails' in
          let S_all' := Union search_thread S' S0' in
            let S_H' := Add search_heap S_H0' (H'', hp') in
              let trails' := Add trail thread_trails' (heap_trail hp') in
                (forall t', 
                  In trail thread_trails' t' ->
                  exists id, exists p', exists list_M', exists e', 
                    t' = thread_trail id p' /\
                    In hl_thread S_hl' (id, list_M', e')) /\
                (forall id list_M' e',
                  In hl_thread S_hl' (id, list_M', e') ->
                  exists p', 
                    In trail thread_trails' (thread_trail id p')) /\
                committable trails' /\
                (ll_step (frozen H) T S_susp S_H S_all
                  (frozen H) T S_susp S_H' S_all')) as no_ld.
eapply hl2ll_no_ld.
apply hl_steps.
unfold ld_unique_tids in S_hl_unique. eapply proj1. apply S_hl_unique.
apply trails_in_S_hl.
apply S_hl_in_trails.
apply S_H_eq.
apply S_eq.
apply S_all_eq.
apply trails_eq.
apply comm_before.
destruct no_ld as [ thread_trails' [ hp' [ S_H0' [ S0' [ trails'_in_S_hl' [ S_hl'_in_trails' [ comm_after ll_steps ] ] ] ] ] ] ].
exists thread_trails'. exists hp'. exists (Add search_heap S_H0' (H'', hp')). exists S0'. exists (get_S_no_ld S_hl' thread_trails').
intros S_all' trails'.
split. subst trails'. apply comm_after.
split. subst S_all'. apply ll_steps.
left. 
split. reflexivity.
exists S_H0'.
split. reflexivity.
split. reflexivity.
split. apply trails'_in_S_hl'.
apply S_hl'_in_trails'.

destruct ld_before as [ id_ld [ list_M_ld [ e_ld [ s_is_Some [ trails_in_S_hl [ S_hl_in_trails S_eq ] ] ] ] ] ].
subst s.
induction s' as [ s_ld' | ].

(* ld *)
induction s_ld' as [ [ id_ld' list_M_ld' ] e_ld' ].
assert (exists thread_trails', exists hp', exists S_H', exists S0',
  let S' := get_S_ld H'' S_hl' (id_ld', list_M_ld', e_ld') thread_trails' hp' in
    let S_all' := Union search_thread S' S0' in
      let trails' := Add trail thread_trails' (heap_trail hp') in
        (forall t', 
          In trail thread_trails' t' ->
          exists id, exists p', exists list_M', exists e', 
            t' = thread_trail id p' /\
            (In hl_thread S_hl' (id, list_M', e')
              \/ (id_ld', list_M_ld', e_ld') = (id, list_M', e'))) /\
        (forall id list_M' e',  
          (In hl_thread S_hl' (id, list_M', e') 
            \/ (id_ld', list_M_ld', e_ld') = (id, list_M', e')) ->
          exists p', 
            In trail thread_trails' (thread_trail id p')) /\
        committable trails' /\
        (ll_step (frozen H) T S_susp S_H S_all
          (frozen H) T S_susp S_H' S_all')) as ld.
eapply hl2ll_ld.
apply hl_steps.
apply S_hl_unique.
apply trails_in_S_hl.
apply S_hl_in_trails.
apply S_eq.
apply S_all_eq.
apply trails_eq.
apply comm_before.
destruct ld as [ thread_trails' [ hp' [ S_H' [ S0' [ trails'_in_S_hl' [ S_hl'_in_trails' [ comm_after ll_steps ] ] ] ] ] ] ].
exists thread_trails'. exists hp'. exists S_H'. exists S0'. exists (get_S_ld H'' S_hl' (id_ld', list_M_ld', e_ld') thread_trails' hp').
intros S_all' trails'.
split. subst trails'. apply comm_after.
split. subst S_all'. apply ll_steps.
right. 
exists id_ld'. exists list_M_ld'. exists e_ld'.
split. reflexivity.
split. reflexivity.
split. apply trails'_in_S_hl'.
apply S_hl'_in_trails'.

(* end ld *)
assert (exists thread_trails', exists hp', exists S_H0', exists S0',
  let S' := get_S_no_ld S_hl' thread_trails' in
    let S_all' := Union search_thread S' S0' in
      let S_H' := Add search_heap S_H0' (H'', hp') in
        let trails' := Add trail thread_trails' (heap_trail hp') in
          (forall t', 
            In trail thread_trails' t' ->
            exists id, exists p', exists list_M', exists e', 
              t' = thread_trail id p' /\
              In hl_thread S_hl' (id, list_M', e')) /\
          (forall id list_M' e',  
            In hl_thread S_hl' (id, list_M', e') ->
            exists p', 
              In trail thread_trails' (thread_trail id p')) /\
          committable trails' /\
          (ll_step (frozen H) T S_susp S_H S_all
            (frozen H) T S_susp S_H' S_all')) as end_ld.
eapply hl2ll_end_ld.
apply hl_steps.
apply S_hl_unique.
apply trails_in_S_hl.
apply S_hl_in_trails.
apply S_eq.
apply S_all_eq.
apply trails_eq.
apply comm_before.
destruct end_ld as [ thread_trails' [ hp' [ S_H0' [ S0' [ trails'_in_S_hl' [ S_hl'_in_trails' [ comm_after ll_steps ] ] ] ] ] ] ].
exists thread_trails'. exists hp'. exists (Add search_heap S_H0' (H'', hp')). exists S0'. exists (get_S_no_ld S_hl' thread_trails').
intros S_all' trails'.
split. subst trails'. apply comm_after.
split. subst S_all'. apply ll_steps.
left. 
split. reflexivity.
exists S_H0'.
split. reflexivity.
split. reflexivity.
split. apply trails'_in_S_hl'.
apply S_hl'_in_trails'.

Qed.

