Require Import Coq.Sets.Ensembles.
Require Import lowlevel.
Require Import syntax.
Require Import trails.

Lemma extends_implies_nonces_included :
  forall p p',
    extends p' p ->
    Included nonce (nonces_path p) (nonces_path p').

intros p p' p'_extends.

induction p'_extends as [ | elt p'' ].
unfold Included. auto.
induction elt as [ | | n_x id_x p_x | n_x id_x p_x | n_x hp_x ];
simpl; auto.
unfold Included. intros x x_in_p2.
left. right.
unfold Included in IHp'_extends.
auto.
unfold Included. intros x x_in_p2.
left. right.
unfold Included in IHp'_extends.
auto.
unfold Included. intros x x_in_p2.
left. right.
unfold Included in IHp'_extends.
auto.

Qed.

Lemma heap_extends_implies_nonces_included :
  forall p p',
    heap_extends p' p ->
    Included nonce (nonces_heap_path p) (nonces_heap_path p').

intros p p' p'_extends.

induction p'_extends as [ | elt p'' ].
unfold Included. auto.
induction elt as [ n_x id_x p_x ];
simpl; auto.
unfold Included. intros x x_in_p2.
left. right. auto.

Qed.